/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef AXIS_AXISRECORDER_H
#define AXIS_AXISRECORDER_H

#include <Controller.h>
#include <fstream>
#include <memory>

namespace axis {

class AxisRecorder : public ExperimentController {

public:
	//! Type of controller
	static const std::string TYPE;

	AxisRecorder(const std::string& name);
	AxisRecorder(const AxisRecorder& controller);
	virtual ~AxisRecorder();

	virtual void postConfiguration();

	void updateActualPosition(const std::string& controllerName);

private:
	std::auto_ptr<std::ofstream> m_dataFile;
	int64 m_initialDate;
	std::map<string, ExperimentController*> m_experimentControllersMap;

};

}

#endif
