/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef DFK31AU03DEF_H
#define DFK31AU03DEF_H

namespace dfk41au03 {

static const std::string RGB = "RGB";
static const std::string PNG = "PNG";
static const int32 RGB24BIT = 24;
static const int32 XSIZE = 1024;
static const int32 YSIZE = 768;
static const int32 COUNT_IGNORE	= 3;	// frame count for initilize camera

enum {
	READOUT_NOT_ACTIVE = 0,
	EXPOSURE_IN_PROGRESS,
	READOUT_IN_PROGRESS,
	READOUT_COMPLETE,
	FRAME_AVAILABLE = READOUT_COMPLETE,
	READOUT_FAILED,
	ACQUISITION_IN_PROGRESS,
	MAX_CAMERA_STATUS
};

}

#endif //DFK31AU03DEF_H
