/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#include "UsbPVCamBridge.h"

#include <cstdlib>

#include "master.h"
#include "pvcam.h"

int plExpUninitSeq() {
	return pl_exp_uninit_seq();
}

int plCamClose(short hCam) {
	return pl_cam_close(hCam);
}

int plPVCamUninit() {
	return pl_pvcam_uninit();
}

int plPVCamInit() {
	return pl_pvcam_init();
}

int plCamGetName(short camNum, char * camName) {
	return pl_cam_get_name(camNum, camName);
}

int plCamOpen(char * camName, short * hCam) {
	return pl_cam_open(camName, hCam, OPEN_EXCLUSIVE);
}

int plExpFinishSeq(short hCam, void * pixelStream, short hBuf) {
	return pl_exp_finish_seq(hCam, pixelStream, hBuf);
}

void * allocRegion() {
	rgn_type * region;
	region = (rgn_type *) malloc(sizeof(rgn_type));
	return region;
}

void setS1(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->s1 = value;
}

void setS2(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->s2 = value;
}

void setP1(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->p1 = value;
}

void setP2(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->p2 = value;
}

void setSBin(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->sbin = value;
}

void setPBin(void * region, unsigned short value) {
	rgn_type * rgn = (rgn_type *) region;
	rgn->pbin = value;
}

int plGetParam(short hCam, unsigned long paramId, short paramAttribute, void * paramValue) {
	return pl_get_param(hCam, paramId, paramAttribute, paramValue);
}

int plExpInitSeq() {
	return pl_exp_init_seq();
}

int plExpSetupSeq(short hCam, unsigned short expTotal, unsigned short rgnTotal, void const * rgn, short expMode,
		unsigned long exposureTime, unsigned long * expBytes) {
	return pl_exp_setup_seq(hCam, expTotal, rgnTotal, (const rgn_type *) rgn, expMode, exposureTime, expBytes);
}

int plExpStartSeq(short hCam, void * pixelStream) {
	return pl_exp_start_seq(hCam, pixelStream);
}

int plExpAbort(short hCam, short camState) {
	return pl_exp_abort(hCam, camState);
}

int plExpCheckStatus(short hCam, short * status, unsigned long * bytesArrived) {
	return pl_exp_check_status(hCam, status, bytesArrived);
}

short plErrorCode() {
	return pl_error_code();
}

int plErrorMessage(short errCode, char * message) {
	return pl_error_message(errCode, message);
}
